> ## Documentation Index
> Fetch the complete documentation index at: https://docs.withampersand.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List installations for a project

> Lists all installations across every integration in a project, giving you a complete view of all active customer integrations. To narrow results to a single integration, use listInstallations instead.




## OpenAPI

````yaml platform get /projects/{projectIdOrName}/installations
openapi: 3.0.1
info:
  title: Ampersand public API
  version: 1.0.0
servers:
  - url: https://api.withampersand.com/v1
security:
  - APIKeyHeader: []
  - Bearer: []
paths:
  /projects/{projectIdOrName}/installations:
    get:
      tags:
        - Installation
      summary: List installations for a project
      description: >
        Lists all installations across every integration in a project, giving
        you a complete view of all active customer integrations. To narrow
        results to a single integration, use listInstallations instead.
      operationId: listInstallationsForProject
      parameters:
        - name: projectIdOrName
          in: path
          required: true
          description: The Ampersand project ID or project name.
          schema:
            type: string
          example: my-project
        - name: groupRef
          in: query
          description: >-
            The ID that your app uses to identify a group of users (e.g. an org
            ID, workspace ID, or team ID). When provided, only returns
            installations belonging to this group.
          example: group-123
          schema:
            type: string
      responses:
        '200':
          description: List of installations
          content:
            application/json:
              schema:
                type: array
                items:
                  title: Installation
                  required:
                    - config
                    - connection
                    - createTime
                    - createdBy
                    - healthStatus
                    - id
                    - integrationId
                    - projectId
                  type: object
                  properties:
                    id:
                      type: string
                      description: The installation ID.
                    projectId:
                      type: string
                      description: The Ampersand project ID.
                      example: project-456
                    integrationId:
                      type: string
                      description: The integration ID.
                    group:
                      title: Group
                      required:
                        - createTime
                        - groupName
                        - groupRef
                        - projectId
                      type: object
                      properties:
                        groupRef:
                          type: string
                          description: >-
                            The ID of the user group that has access to this
                            installation.
                          example: group-123
                        groupName:
                          type: string
                          description: >-
                            The name of the user group that has access to this
                            installation.
                          example: Super Customer
                        projectId:
                          type: string
                          description: The Ampersand project ID.
                          example: project-456
                        createTime:
                          type: string
                          description: The time the group was created.
                          format: date-time
                          example: '2023-07-13T21:34:44.816Z'
                        updateTime:
                          type: string
                          description: The time the group was last updated.
                          format: date-time
                          example: '2023-07-13T21:34:44.816Z'
                    healthStatus:
                      type: string
                      enum:
                        - healthy
                        - unhealthy
                      description: The health status of the installation.
                      example: healthy
                    lastOperationStatus:
                      type: string
                      enum:
                        - success
                        - failure
                        - in_progress
                      description: >
                        The status of the latest operation for this
                        installation.
                      example: success
                    connection:
                      title: Connection
                      required:
                        - id
                        - createTime
                        - group
                        - consumer
                        - projectId
                        - provider
                        - authScheme
                        - status
                      type: object
                      properties:
                        id:
                          type: string
                          description: The connection ID.
                          example: connection-123
                        projectId:
                          type: string
                          description: The Ampersand project ID.
                          example: project-456
                        provider:
                          type: string
                          description: The SaaS provider that this Connection is for.
                          example: salesforce
                        providerApp:
                          title: Provider App
                          required:
                            - clientId
                            - createTime
                            - id
                            - projectId
                            - provider
                          type: object
                          properties:
                            id:
                              type: string
                              description: The provider app ID.
                              example: provider-app-123
                            projectId:
                              type: string
                              description: The Ampersand project ID.
                              example: project-456
                            externalRef:
                              type: string
                              description: >-
                                The ID used by the provider to identify the app
                                (optional).
                              example: external-id-123
                            provider:
                              type: string
                              description: The SaaS provider that this app connects to.
                              example: salesforce
                            clientId:
                              type: string
                              description: The OAuth client ID for this app.
                              example: client-id-123
                            scopes:
                              type: array
                              description: The OAuth scopes for this app.
                              items:
                                type: string
                                example:
                                  - oauth
                                  - offline
                                  - crm.read
                            metadata:
                              title: Provider App Metadata
                              type: object
                              description: >-
                                Provider-specific configuration that extends the
                                standard OAuth flow.
                              properties:
                                authQueryParams:
                                  type: object
                                  description: >-
                                    Additional query parameters to include in
                                    the OAuth authorization URL (e.g.,
                                    optional_scope for HubSpot).
                                  additionalProperties:
                                    type: array
                                    items:
                                      type: string
                                  example:
                                    optional_scope:
                                      - automation.sequences.read
                                providerParams:
                                  type: object
                                  description: >-
                                    Provider-specific string values keyed by
                                    names (e.g., packageInstallURL for
                                    Salesforce, gcpProjectId and
                                    gcpPubSubTopicName for Gmail).
                                  additionalProperties:
                                    type: string
                                  example:
                                    packageInstallURL: >-
                                      https://login.salesforce.com/packaging/installPackage.apexp?p0=04t123456789
                                    gcpProjectId: my-gcp-project
                                    gcpPubSubTopicName: my-topic
                            createTime:
                              type: string
                              description: The time the provider app was created.
                              format: date-time
                            updateTime:
                              type: string
                              description: The time the provider app was updated.
                              format: date-time
                        group:
                          title: Group
                          required:
                            - createTime
                            - groupName
                            - groupRef
                            - projectId
                          type: object
                          properties:
                            groupRef:
                              type: string
                              description: >-
                                The ID of the user group that has access to this
                                installation.
                              example: group-123
                            groupName:
                              type: string
                              description: >-
                                The name of the user group that has access to
                                this installation.
                              example: Super Customer
                            projectId:
                              type: string
                              description: The Ampersand project ID.
                              example: project-456
                            createTime:
                              type: string
                              description: The time the group was created.
                              format: date-time
                              example: '2023-07-13T21:34:44.816Z'
                            updateTime:
                              type: string
                              description: The time the group was last updated.
                              format: date-time
                              example: '2023-07-13T21:34:44.816Z'
                        consumer:
                          title: Consumer
                          required:
                            - consumerName
                            - consumerRef
                            - createTime
                            - projectId
                          type: object
                          properties:
                            consumerRef:
                              type: string
                              description: The consumer reference.
                              example: consumer-123
                            consumerName:
                              type: string
                              description: The name of the consumer.
                              example: Super Customer
                            projectId:
                              type: string
                              description: The Ampersand project ID.
                              example: project-456
                            createTime:
                              type: string
                              description: The time the consumer was created.
                              format: date-time
                              example: '2023-07-13T21:34:44.816Z'
                            updateTime:
                              type: string
                              description: The time the consumer was last updated.
                              format: date-time
                              example: '2023-07-13T21:34:44.816Z'
                        providerWorkspaceRef:
                          type: string
                          description: >-
                            If available, the identifier for the provider
                            workspace (e.g. the Salesforce subdomain)
                          example: provider-workspace-123
                        providerConsumerRef:
                          type: string
                          description: >-
                            If available, the ID that Salesforce/Hubspot uses to
                            identify this user (e.g. Salesforce has IDs in the
                            form of
                            https://login.salesforce.com/id/00D4x0000019CQTEA2/0054x000000orJ4AA)
                          example: provider-consumer-123
                        createTime:
                          type: string
                          description: The time the connection was created.
                          format: date-time
                          example: '2023-07-13T21:34:44.816Z'
                        updateTime:
                          type: string
                          description: The time the connection was last updated.
                          format: date-time
                          example: '2023-07-13T21:34:44.816Z'
                        authScheme:
                          type: string
                          description: The authentication scheme used for this connection.
                          example: oauth2/authorizationCode
                          enum:
                            - none
                            - apiKey
                            - basic
                            - oauth2/authorizationCode
                            - oauth2/authorizationCodePKCE
                            - oauth2/clientCredentials
                            - oauth2/password
                        status:
                          type: string
                          description: >
                            The status of the connection.

                            - `created`: The connection has just been created or
                            the access token was just refreshed.

                            - `working`: The connection has successfully been
                            used to make a request.

                            - `bad_credentials`: The connection encountered
                            credential-related issues when making a request, or
                            when attempting to refresh the access token.
                          example: working
                          enum:
                            - created
                            - working
                            - bad_credentials
                        oauth2AuthorizationCode:
                          title: OAuth2 AuthorizationCode Token
                          type: object
                          properties:
                            accessToken:
                              type: object
                              required:
                                - token
                              description: The access token for the connection.
                              properties:
                                token:
                                  type: string
                                issuedAt:
                                  type: string
                                  format: date-time
                                  example: '2024-04-22T18:55:28.456076Z'
                                expiresAt:
                                  type: string
                                  format: date-time
                                  example: '2024-10-22T18:55:28.456076Z'
                            refreshToken:
                              type: object
                              required:
                                - token
                              description: The refresh token to use for the connection.
                              properties:
                                token:
                                  type: string
                                issuedAt:
                                  type: string
                                  format: date-time
                                  example: '2024-04-22T18:55:28.456076Z'
                                expiresAt:
                                  type: string
                                  format: date-time
                                  example: '2024-10-22T18:55:28.456076Z'
                            scopes:
                              type: array
                              items:
                                type: string
                              description: The scopes for the tokens.
                        apiKey:
                          type: string
                          description: The API key used while making the connection.
                          example: api-key-123
                        providerMetadata:
                          title: Provider Metadata
                          type: object
                          additionalProperties:
                            title: Provider Metadata Info
                            type: object
                            required:
                              - value
                              - source
                            properties:
                              value:
                                type: string
                                description: The value of the metadata field
                                example: '1234567890'
                              source:
                                type: string
                                description: The source of the metadata field
                                enum:
                                  - input
                                  - token
                                  - provider
                                example: input
                              displayName:
                                type: string
                                description: The human-readable name for the field
                                example: Account ID
                    createTime:
                      type: string
                      description: The time the installation was created.
                      format: date-time
                    createdBy:
                      type: string
                      description: >-
                        The person who did the installation, in the format of
                        "consumer:{consumer-id}".
                      example: consumer:consumer-123
                    updateTime:
                      type: string
                      description: >-
                        The time the installation was last updated with a new
                        config.
                      format: date-time
                    config:
                      title: Config
                      required:
                        - content
                        - createTime
                        - createdBy
                        - id
                        - revisionId
                      type: object
                      properties:
                        id:
                          type: string
                          description: The config ID.
                          example: config-123
                        revisionId:
                          type: string
                          description: >
                            The ID of the revision that was current when this
                            config was created or last updated.
                          example: revision-123
                        createTime:
                          type: string
                          description: The time the config was created.
                          format: date-time
                        createdBy:
                          type: string
                          description: >-
                            The person who created the config, in the format of
                            "consumer:{consumer-id}" or "builder:{builder-id}".
                          example: builder:builder-123
                        content:
                          title: Config Content
                          allOf:
                            - title: Base Config Content
                              type: object
                              properties:
                                provider:
                                  description: The SaaS API that we are integrating with.
                                  example: hubspot
                                  type: string
                                read:
                                  title: Base Read Config
                                  type: object
                                  properties:
                                    objects:
                                      type: object
                                      description: >-
                                        This is a map of object names to their
                                        configuration.
                                      additionalProperties:
                                        title: Base Read Config Object
                                        type: object
                                        properties:
                                          objectName:
                                            description: The name of the object to read from.
                                            example: account
                                            type: string
                                            x-oapi-codegen-extra-tags:
                                              validate: required
                                          schedule:
                                            type: string
                                            description: >-
                                              The schedule for reading the object, in
                                              cron syntax.
                                            example: '*/15 * * * *'
                                            x-go-type-skip-optional-pointer: true
                                          disabled:
                                            type: boolean
                                            description: >-
                                              If this flag is set to true, scheduled
                                              reads associated with this object will
                                              be paused, and on-demand reads will not
                                              be allowed.
                                            default: false
                                          destination:
                                            description: >-
                                              The name of the destination that the
                                              result should be sent to.
                                            example: accountWebhook
                                            type: string
                                            x-go-type-skip-optional-pointer: true
                                          selectedFields:
                                            type: object
                                            description: >-
                                              This is a map of field names to booleans
                                              indicating whether they should be read.
                                              If a field is already included in
                                              `selectedFieldMappings`, it does not
                                              need to be included here.
                                            example: '{ phone: true, fax: true }'
                                            additionalProperties:
                                              type: boolean
                                          selectedValueMappings:
                                            type: object
                                            description: >-
                                              This is a map of field names to their
                                              value mappings.
                                            example:
                                              stage:
                                                open: scheduled
                                                closedWon: won
                                                closedLost: lost
                                            x-go-type-skip-optional-pointer: true
                                            additionalProperties:
                                              title: Selected Value Mappings
                                              type: object
                                              description: >-
                                                This is a map of values to their
                                                mappings. The key is the value delivered
                                                to the webhook, the value is the value
                                                coming from the provider API.
                                              example:
                                                open: scheduled
                                                closedWon: won
                                                closedLost: lost
                                              x-go-type-skip-optional-pointer: true
                                              additionalProperties:
                                                type: string
                                          dynamicMappingsInput:
                                            title: Dynamic Mappings Input
                                            description: >-
                                              An array containing all available
                                              dynamic field and value mappings for
                                              this installation, provided by the
                                              InstallIntegration component. This array
                                              represents the complete set of possible
                                              mappings, regardless of which ones are
                                              currently selected. The actual selected
                                              mappings are stored separately in the
                                              selectedFieldMappings property.
                                            type: array
                                            items:
                                              title: Field Mapping Entry
                                              type: object
                                              required:
                                                - mapToName
                                              properties:
                                                mapToName:
                                                  type: string
                                                  description: >-
                                                    The name of the field in your
                                                    application.
                                                mapToDisplayName:
                                                  type: string
                                                  description: >-
                                                    Optional display name of the field to
                                                    show the user in the mapping UI.
                                                prompt:
                                                  type: string
                                                  description: >-
                                                    Optional prompt to show the user in the
                                                    mapping UI.
                                                mappedValues:
                                                  type: array
                                                  description: >-
                                                    If you would like the user to map a set
                                                    of possible values, this is the list of
                                                    possible values of the field in your
                                                    application.
                                                  items:
                                                    title: Mapped Value
                                                    type: object
                                                    required:
                                                      - mappedValue
                                                      - mappedDisplayValue
                                                    properties:
                                                      mappedValue:
                                                        type: string
                                                      mappedDisplayValue:
                                                        type: string
                                                fieldName:
                                                  type: string
                                                  description: >-
                                                    The name of the field in SaaS provider,
                                                    if present, then we will not prompt the
                                                    user to map the field.
                                          selectedFieldMappings:
                                            type: object
                                            description: >-
                                              This is a map of mapToNames to field
                                              names. (A mapTo name is the name the
                                              builder wants to map a field to when it
                                              lands in their destination.)
                                            example: '{ phoneNumber: phone, faxNumber: fax }'
                                            additionalProperties:
                                              type: string
                                          selectedFieldsAuto:
                                            title: Selected Fields Auto Config
                                            description: >-
                                              If selectedFieldsAuto is set to all, all
                                              fields will be read.
                                            type: string
                                            enum:
                                              - all
                                            x-enum-varnames:
                                              - SelectedFieldsAll
                                          backfill:
                                            title: Backfill Config
                                            type: object
                                            required:
                                              - defaultPeriod
                                            properties:
                                              defaultPeriod:
                                                title: Default Period Config
                                                type: object
                                                properties:
                                                  days:
                                                    type: integer
                                                    description: >-
                                                      Number of days in past to backfill from.
                                                      0 is no backfill. e.g) if 10, then
                                                      backfill last 10 days of data. Required
                                                      if fullHistory is not set.
                                                    minimum: 0
                                                    example: 30
                                                    x-oapi-codegen-extra-tags:
                                                      validate: >-
                                                        required_without=FullHistory,omitempty,min=0
                                                  fullHistory:
                                                    type: boolean
                                                    description: >-
                                                      If true, backfill all history. Required
                                                      if days is not set.
                                                    example: false
                                                    x-oapi-codegen-extra-tags:
                                                      validate: required_without=Days
                                              fieldFilters:
                                                type: array
                                                description: >
                                                  Filters to apply only during backfill.
                                                  Multiple conditions are joined by AND.
                                                  Use this when you want different filter
                                                  behavior for backfill vs. incremental
                                                  reads.
                                                x-go-type-skip-optional-pointer: true
                                                items:
                                                  title: Read Filter
                                                  type: object
                                                  required:
                                                    - fieldName
                                                    - operator
                                                  properties:
                                                    fieldName:
                                                      type: string
                                                      description: The name of the field to filter on.
                                                      example: status
                                                    operator:
                                                      type: string
                                                      description: The comparison operator.
                                                      enum:
                                                        - eq
                                                      example: eq
                                                    value:
                                                      title: Read Filter Value
                                                      description: >-
                                                        The value to filter on. Allowed types
                                                        are string, boolean, and number.
                                                      example: active
                                          fieldFilters:
                                            type: array
                                            description: >
                                              Filters to apply when reading records
                                              during incremental reads and backfill.
                                              Multiple conditions are joined by AND.
                                              Each field can only have one condition.
                                            x-go-type-skip-optional-pointer: true
                                            items:
                                              title: Read Filter
                                              type: object
                                              required:
                                                - fieldName
                                                - operator
                                              properties:
                                                fieldName:
                                                  type: string
                                                  description: The name of the field to filter on.
                                                  example: status
                                                operator:
                                                  type: string
                                                  description: The comparison operator.
                                                  enum:
                                                    - eq
                                                  example: eq
                                                value:
                                                  title: Read Filter Value
                                                  description: >-
                                                    The value to filter on. Allowed types
                                                    are string, boolean, and number.
                                                  example: active
                                write:
                                  title: Base Write Config
                                  type: object
                                  properties:
                                    objects:
                                      type: object
                                      description: >-
                                        This is a map of object names to their
                                        configuration.
                                      additionalProperties:
                                        title: Base Write Config Object
                                        type: object
                                        required:
                                          - objectName
                                        properties:
                                          objectName:
                                            description: The name of the object to write to.
                                            example: account
                                            type: string
                                            x-oapi-codegen-extra-tags:
                                              validate: required
                                          deletionSettings:
                                            title: Deletion Settings
                                            type: object
                                            required:
                                              - enabled
                                            properties:
                                              enabled:
                                                type: boolean
                                                description: >-
                                                  Whether deletion is enabled for this
                                                  object
                                                example: true
                                          selectedValueDefaults:
                                            type: object
                                            deprecated: true
                                            description: >-
                                              This is a map of field names to default
                                              values. These values will be used when
                                              writing to the object.
                                            x-go-type-skip-optional-pointer: true
                                            additionalProperties:
                                              title: Value Default (Legacy)
                                              deprecated: true
                                              x-go-type: any
                                              oneOf:
                                                - title: Value Default String
                                                  type: object
                                                  required:
                                                    - value
                                                  properties:
                                                    value:
                                                      type: string
                                                      description: The value to be used as a default.
                                                    applyOnUpdate:
                                                      type: string
                                                      enum:
                                                        - always
                                                        - never
                                                      description: >
                                                        Whether the default value should be
                                                        applied when updating a record.

                                                        If set to `always`, the default value
                                                        will be applied when updating a record.

                                                        If set to `never`, the default value
                                                        will not be applied when updating a
                                                        record,

                                                        only when creating a record.

                                                        If unspecified, then `always` is
                                                        assumed.
                                                - title: Value Default Integer
                                                  type: object
                                                  required:
                                                    - value
                                                  properties:
                                                    value:
                                                      type: integer
                                                      description: The value to be used as a default.
                                                    applyOnUpdate:
                                                      type: string
                                                      enum:
                                                        - always
                                                        - never
                                                      description: >
                                                        Whether the default value should be
                                                        applied when updating a record.

                                                        If set to `always`, the default value
                                                        will be applied when updating a record.

                                                        If set to `never`, the default value
                                                        will not be applied when updating a
                                                        record,

                                                        only when creating a record.

                                                        If unspecified, then `always` is
                                                        assumed.
                                                - title: Value Default Boolean
                                                  type: object
                                                  required:
                                                    - value
                                                  properties:
                                                    value:
                                                      type: boolean
                                                      description: The value to be used as a default.
                                                    applyOnUpdate:
                                                      type: string
                                                      enum:
                                                        - always
                                                        - never
                                                      description: >
                                                        Whether the default value should be
                                                        applied when updating a record.

                                                        If set to `always`, the default value
                                                        will be applied when updating a record.

                                                        If set to `never`, the default value
                                                        will not be applied when updating a
                                                        record,

                                                        only when creating a record.

                                                        If unspecified, then `always` is
                                                        assumed.
                                          selectedFieldSettings:
                                            type: object
                                            description: >-
                                              This is a map of field names to their
                                              settings.
                                            x-go-type-skip-optional-pointer: true
                                            additionalProperties:
                                              title: Field setting
                                              type: object
                                              properties:
                                                default:
                                                  title: Default value for a field
                                                  description: >-
                                                    Only use one of stringValue,
                                                    integerValue, booleanValue.
                                                  type: object
                                                  properties:
                                                    stringValue:
                                                      type: string
                                                      description: >-
                                                        The default string value to apply to a
                                                        field
                                                    integerValue:
                                                      type: integer
                                                      description: >-
                                                        The default integer value to apply to a
                                                        field
                                                    booleanValue:
                                                      type: boolean
                                                      description: >-
                                                        The default boolean value to apply to a
                                                        field
                                                writeOnCreate:
                                                  type: string
                                                  enum:
                                                    - always
                                                    - never
                                                  default: always
                                                  x-go-type-skip-optional-pointer: true
                                                  description: >-
                                                    Whether the default value should be
                                                    applied when creating a record.
                                                writeOnUpdate:
                                                  type: string
                                                  enum:
                                                    - always
                                                    - never
                                                    - ifEmpty
                                                  default: always
                                                  x-go-type-skip-optional-pointer: true
                                                  description: >
                                                    Whether the default value should be
                                                    applied when updating a record.

                                                    - always: Always write to the field on
                                                    update

                                                    - never: Never write to the field on
                                                    update

                                                    - ifEmpty: Only write to the field if
                                                    it's currently empty (unset or empty
                                                    string). 
                                proxy:
                                  title: Base Proxy Config
                                  type: object
                                  properties:
                                    enabled:
                                      type: boolean
                            - type: object
                              required:
                                - provider
                              properties:
                                read:
                                  title: Read Config
                                  allOf:
                                    - title: Base Read Config
                                      type: object
                                      properties:
                                        objects:
                                          type: object
                                          description: >-
                                            This is a map of object names to their
                                            configuration.
                                          additionalProperties:
                                            title: Base Read Config Object
                                            type: object
                                            properties:
                                              objectName:
                                                description: The name of the object to read from.
                                                example: account
                                                type: string
                                                x-oapi-codegen-extra-tags:
                                                  validate: required
                                              schedule:
                                                type: string
                                                description: >-
                                                  The schedule for reading the object, in
                                                  cron syntax.
                                                example: '*/15 * * * *'
                                                x-go-type-skip-optional-pointer: true
                                              disabled:
                                                type: boolean
                                                description: >-
                                                  If this flag is set to true, scheduled
                                                  reads associated with this object will
                                                  be paused, and on-demand reads will not
                                                  be allowed.
                                                default: false
                                              destination:
                                                description: >-
                                                  The name of the destination that the
                                                  result should be sent to.
                                                example: accountWebhook
                                                type: string
                                                x-go-type-skip-optional-pointer: true
                                              selectedFields:
                                                type: object
                                                description: >-
                                                  This is a map of field names to booleans
                                                  indicating whether they should be read.
                                                  If a field is already included in
                                                  `selectedFieldMappings`, it does not
                                                  need to be included here.
                                                example: '{ phone: true, fax: true }'
                                                additionalProperties:
                                                  type: boolean
                                              selectedValueMappings:
                                                type: object
                                                description: >-
                                                  This is a map of field names to their
                                                  value mappings.
                                                example:
                                                  stage:
                                                    open: scheduled
                                                    closedWon: won
                                                    closedLost: lost
                                                x-go-type-skip-optional-pointer: true
                                                additionalProperties:
                                                  title: Selected Value Mappings
                                                  type: object
                                                  description: >-
                                                    This is a map of values to their
                                                    mappings. The key is the value delivered
                                                    to the webhook, the value is the value
                                                    coming from the provider API.
                                                  example:
                                                    open: scheduled
                                                    closedWon: won
                                                    closedLost: lost
                                                  x-go-type-skip-optional-pointer: true
                                                  additionalProperties:
                                                    type: string
                                              dynamicMappingsInput:
                                                title: Dynamic Mappings Input
                                                description: >-
                                                  An array containing all available
                                                  dynamic field and value mappings for
                                                  this installation, provided by the
                                                  InstallIntegration component. This array
                                                  represents the complete set of possible
                                                  mappings, regardless of which ones are
                                                  currently selected. The actual selected
                                                  mappings are stored separately in the
                                                  selectedFieldMappings property.
                                                type: array
                                                items:
                                                  title: Field Mapping Entry
                                                  type: object
                                                  required:
                                                    - mapToName
                                                  properties:
                                                    mapToName:
                                                      type: string
                                                      description: >-
                                                        The name of the field in your
                                                        application.
                                                    mapToDisplayName:
                                                      type: string
                                                      description: >-
                                                        Optional display name of the field to
                                                        show the user in the mapping UI.
                                                    prompt:
                                                      type: string
                                                      description: >-
                                                        Optional prompt to show the user in the
                                                        mapping UI.
                                                    mappedValues:
                                                      type: array
                                                      description: >-
                                                        If you would like the user to map a set
                                                        of possible values, this is the list of
                                                        possible values of the field in your
                                                        application.
                                                      items:
                                                        title: Mapped Value
                                                        type: object
                                                        required:
                                                          - mappedValue
                                                          - mappedDisplayValue
                                                        properties:
                                                          mappedValue:
                                                            type: string
                                                          mappedDisplayValue:
                                                            type: string
                                                    fieldName:
                                                      type: string
                                                      description: >-
                                                        The name of the field in SaaS provider,
                                                        if present, then we will not prompt the
                                                        user to map the field.
                                              selectedFieldMappings:
                                                type: object
                                                description: >-
                                                  This is a map of mapToNames to field
                                                  names. (A mapTo name is the name the
                                                  builder wants to map a field to when it
                                                  lands in their destination.)
                                                example: '{ phoneNumber: phone, faxNumber: fax }'
                                                additionalProperties:
                                                  type: string
                                              selectedFieldsAuto:
                                                title: Selected Fields Auto Config
                                                description: >-
                                                  If selectedFieldsAuto is set to all, all
                                                  fields will be read.
                                                type: string
                                                enum:
                                                  - all
                                                x-enum-varnames:
                                                  - SelectedFieldsAll
                                              backfill:
                                                title: Backfill Config
                                                type: object
                                                required:
                                                  - defaultPeriod
                                                properties:
                                                  defaultPeriod:
                                                    title: Default Period Config
                                                    type: object
                                                    properties:
                                                      days:
                                                        type: integer
                                                        description: >-
                                                          Number of days in past to backfill from.
                                                          0 is no backfill. e.g) if 10, then
                                                          backfill last 10 days of data. Required
                                                          if fullHistory is not set.
                                                        minimum: 0
                                                        example: 30
                                                        x-oapi-codegen-extra-tags:
                                                          validate: >-
                                                            required_without=FullHistory,omitempty,min=0
                                                      fullHistory:
                                                        type: boolean
                                                        description: >-
                                                          If true, backfill all history. Required
                                                          if days is not set.
                                                        example: false
                                                        x-oapi-codegen-extra-tags:
                                                          validate: required_without=Days
                                                  fieldFilters:
                                                    type: array
                                                    description: >
                                                      Filters to apply only during backfill.
                                                      Multiple conditions are joined by AND.
                                                      Use this when you want different filter
                                                      behavior for backfill vs. incremental
                                                      reads.
                                                    x-go-type-skip-optional-pointer: true
                                                    items:
                                                      title: Read Filter
                                                      type: object
                                                      required:
                                                        - fieldName
                                                        - operator
                                                      properties:
                                                        fieldName:
                                                          type: string
                                                          description: The name of the field to filter on.
                                                          example: status
                                                        operator:
                                                          type: string
                                                          description: The comparison operator.
                                                          enum:
                                                            - eq
                                                          example: eq
                                                        value:
                                                          title: Read Filter Value
                                                          description: >-
                                                            The value to filter on. Allowed types
                                                            are string, boolean, and number.
                                                          example: active
                                              fieldFilters:
                                                type: array
                                                description: >
                                                  Filters to apply when reading records
                                                  during incremental reads and backfill.
                                                  Multiple conditions are joined by AND.
                                                  Each field can only have one condition.
                                                x-go-type-skip-optional-pointer: true
                                                items:
                                                  title: Read Filter
                                                  type: object
                                                  required:
                                                    - fieldName
                                                    - operator
                                                  properties:
                                                    fieldName:
                                                      type: string
                                                      description: The name of the field to filter on.
                                                      example: status
                                                    operator:
                                                      type: string
                                                      description: The comparison operator.
                                                      enum:
                                                        - eq
                                                      example: eq
                                                    value:
                                                      title: Read Filter Value
                                                      description: >-
                                                        The value to filter on. Allowed types
                                                        are string, boolean, and number.
                                                      example: active
                                    - type: object
                                      required:
                                        - objects
                                      properties:
                                        objects:
                                          additionalProperties:
                                            title: Read Config Object
                                            allOf:
                                              - title: Base Read Config Object
                                                type: object
                                                properties:
                                                  objectName:
                                                    description: The name of the object to read from.
                                                    example: account
                                                    type: string
                                                    x-oapi-codegen-extra-tags:
                                                      validate: required
                                                  schedule:
                                                    type: string
                                                    description: >-
                                                      The schedule for reading the object, in
                                                      cron syntax.
                                                    example: '*/15 * * * *'
                                                    x-go-type-skip-optional-pointer: true
                                                  disabled:
                                                    type: boolean
                                                    description: >-
                                                      If this flag is set to true, scheduled
                                                      reads associated with this object will
                                                      be paused, and on-demand reads will not
                                                      be allowed.
                                                    default: false
                                                  destination:
                                                    description: >-
                                                      The name of the destination that the
                                                      result should be sent to.
                                                    example: accountWebhook
                                                    type: string
                                                    x-go-type-skip-optional-pointer: true
                                                  selectedFields:
                                                    type: object
                                                    description: >-
                                                      This is a map of field names to booleans
                                                      indicating whether they should be read.
                                                      If a field is already included in
                                                      `selectedFieldMappings`, it does not
                                                      need to be included here.
                                                    example: '{ phone: true, fax: true }'
                                                    additionalProperties:
                                                      type: boolean
                                                  selectedValueMappings:
                                                    type: object
                                                    description: >-
                                                      This is a map of field names to their
                                                      value mappings.
                                                    example:
                                                      stage:
                                                        open: scheduled
                                                        closedWon: won
                                                        closedLost: lost
                                                    x-go-type-skip-optional-pointer: true
                                                    additionalProperties:
                                                      title: Selected Value Mappings
                                                      type: object
                                                      description: >-
                                                        This is a map of values to their
                                                        mappings. The key is the value delivered
                                                        to the webhook, the value is the value
                                                        coming from the provider API.
                                                      example:
                                                        open: scheduled
                                                        closedWon: won
                                                        closedLost: lost
                                                      x-go-type-skip-optional-pointer: true
                                                      additionalProperties:
                                                        type: string
                                                  dynamicMappingsInput:
                                                    title: Dynamic Mappings Input
                                                    description: >-
                                                      An array containing all available
                                                      dynamic field and value mappings for
                                                      this installation, provided by the
                                                      InstallIntegration component. This array
                                                      represents the complete set of possible
                                                      mappings, regardless of which ones are
                                                      currently selected. The actual selected
                                                      mappings are stored separately in the
                                                      selectedFieldMappings property.
                                                    type: array
                                                    items:
                                                      title: Field Mapping Entry
                                                      type: object
                                                      required:
                                                        - mapToName
                                                      properties:
                                                        mapToName:
                                                          type: string
                                                          description: >-
                                                            The name of the field in your
                                                            application.
                                                        mapToDisplayName:
                                                          type: string
                                                          description: >-
                                                            Optional display name of the field to
                                                            show the user in the mapping UI.
                                                        prompt:
                                                          type: string
                                                          description: >-
                                                            Optional prompt to show the user in the
                                                            mapping UI.
                                                        mappedValues:
                                                          type: array
                                                          description: >-
                                                            If you would like the user to map a set
                                                            of possible values, this is the list of
                                                            possible values of the field in your
                                                            application.
                                                          items:
                                                            title: Mapped Value
                                                            type: object
                                                            required:
                                                              - mappedValue
                                                              - mappedDisplayValue
                                                            properties:
                                                              mappedValue:
                                                                type: string
                                                              mappedDisplayValue:
                                                                type: string
                                                        fieldName:
                                                          type: string
                                                          description: >-
                                                            The name of the field in SaaS provider,
                                                            if present, then we will not prompt the
                                                            user to map the field.
                                                  selectedFieldMappings:
                                                    type: object
                                                    description: >-
                                                      This is a map of mapToNames to field
                                                      names. (A mapTo name is the name the
                                                      builder wants to map a field to when it
                                                      lands in their destination.)
                                                    example: '{ phoneNumber: phone, faxNumber: fax }'
                                                    additionalProperties:
                                                      type: string
                                                  selectedFieldsAuto:
                                                    title: Selected Fields Auto Config
                                                    description: >-
                                                      If selectedFieldsAuto is set to all, all
                                                      fields will be read.
                                                    type: string
                                                    enum:
                                                      - all
                                                    x-enum-varnames:
                                                      - SelectedFieldsAll
                                                  backfill:
                                                    title: Backfill Config
                                                    type: object
                                                    required:
                                                      - defaultPeriod
                                                    properties:
                                                      defaultPeriod:
                                                        title: Default Period Config
                                                        type: object
                                                        properties:
                                                          days:
                                                            type: integer
                                                            description: >-
                                                              Number of days in past to backfill from.
                                                              0 is no backfill. e.g) if 10, then
                                                              backfill last 10 days of data. Required
                                                              if fullHistory is not set.
                                                            minimum: 0
                                                            example: 30
                                                            x-oapi-codegen-extra-tags:
                                                              validate: >-
                                                                required_without=FullHistory,omitempty,min=0
                                                          fullHistory:
                                                            type: boolean
                                                            description: >-
                                                              If true, backfill all history. Required
                                                              if days is not set.
                                                            example: false
                                                            x-oapi-codegen-extra-tags:
                                                              validate: required_without=Days
                                                      fieldFilters:
                                                        type: array
                                                        description: >
                                                          Filters to apply only during backfill.
                                                          Multiple conditions are joined by AND.
                                                          Use this when you want different filter
                                                          behavior for backfill vs. incremental
                                                          reads.
                                                        x-go-type-skip-optional-pointer: true
                                                        items:
                                                          title: Read Filter
                                                          type: object
                                                          required:
                                                            - fieldName
                                                            - operator
                                                          properties:
                                                            fieldName:
                                                              type: string
                                                              description: The name of the field to filter on.
                                                              example: status
                                                            operator:
                                                              type: string
                                                              description: The comparison operator.
                                                              enum:
                                                                - eq
                                                              example: eq
                                                            value:
                                                              title: Read Filter Value
                                                              description: >-
                                                                The value to filter on. Allowed types
                                                                are string, boolean, and number.
                                                              example: active
                                                  fieldFilters:
                                                    type: array
                                                    description: >
                                                      Filters to apply when reading records
                                                      during incremental reads and backfill.
                                                      Multiple conditions are joined by AND.
                                                      Each field can only have one condition.
                                                    x-go-type-skip-optional-pointer: true
                                                    items:
                                                      title: Read Filter
                                                      type: object
                                                      required:
                                                        - fieldName
                                                        - operator
                                                      properties:
                                                        fieldName:
                                                          type: string
                                                          description: The name of the field to filter on.
                                                          example: status
                                                        operator:
                                                          type: string
                                                          description: The comparison operator.
                                                          enum:
                                                            - eq
                                                          example: eq
                                                        value:
                                                          title: Read Filter Value
                                                          description: >-
                                                            The value to filter on. Allowed types
                                                            are string, boolean, and number.
                                                          example: active
                                              - type: object
                                                required:
                                                  - objectName
                                                  - selectedFields
                                                  - selectedFieldMappings
                                write:
                                  title: Write Config
                                  allOf:
                                    - title: Base Write Config
                                      type: object
                                      properties:
                                        objects:
                                          type: object
                                          description: >-
                                            This is a map of object names to their
                                            configuration.
                                          additionalProperties:
                                            title: Base Write Config Object
                                            type: object
                                            required:
                                              - objectName
                                            properties:
                                              objectName:
                                                description: The name of the object to write to.
                                                example: account
                                                type: string
                                                x-oapi-codegen-extra-tags:
                                                  validate: required
                                              deletionSettings:
                                                title: Deletion Settings
                                                type: object
                                                required:
                                                  - enabled
                                                properties:
                                                  enabled:
                                                    type: boolean
                                                    description: >-
                                                      Whether deletion is enabled for this
                                                      object
                                                    example: true
                                              selectedValueDefaults:
                                                type: object
                                                deprecated: true
                                                description: >-
                                                  This is a map of field names to default
                                                  values. These values will be used when
                                                  writing to the object.
                                                x-go-type-skip-optional-pointer: true
                                                additionalProperties:
                                                  title: Value Default (Legacy)
                                                  deprecated: true
                                                  x-go-type: any
                                                  oneOf:
                                                    - title: Value Default String
                                                      type: object
                                                      required:
                                                        - value
                                                      properties:
                                                        value:
                                                          type: string
                                                          description: The value to be used as a default.
                                                        applyOnUpdate:
                                                          type: string
                                                          enum:
                                                            - always
                                                            - never
                                                          description: >
                                                            Whether the default value should be
                                                            applied when updating a record.

                                                            If set to `always`, the default value
                                                            will be applied when updating a record.

                                                            If set to `never`, the default value
                                                            will not be applied when updating a
                                                            record,

                                                            only when creating a record.

                                                            If unspecified, then `always` is
                                                            assumed.
                                                    - title: Value Default Integer
                                                      type: object
                                                      required:
                                                        - value
                                                      properties:
                                                        value:
                                                          type: integer
                                                          description: The value to be used as a default.
                                                        applyOnUpdate:
                                                          type: string
                                                          enum:
                                                            - always
                                                            - never
                                                          description: >
                                                            Whether the default value should be
                                                            applied when updating a record.

                                                            If set to `always`, the default value
                                                            will be applied when updating a record.

                                                            If set to `never`, the default value
                                                            will not be applied when updating a
                                                            record,

                                                            only when creating a record.

                                                            If unspecified, then `always` is
                                                            assumed.
                                                    - title: Value Default Boolean
                                                      type: object
                                                      required:
                                                        - value
                                                      properties:
                                                        value:
                                                          type: boolean
                                                          description: The value to be used as a default.
                                                        applyOnUpdate:
                                                          type: string
                                                          enum:
                                                            - always
                                                            - never
                                                          description: >
                                                            Whether the default value should be
                                                            applied when updating a record.

                                                            If set to `always`, the default value
                                                            will be applied when updating a record.

                                                            If set to `never`, the default value
                                                            will not be applied when updating a
                                                            record,

                                                            only when creating a record.

                                                            If unspecified, then `always` is
                                                            assumed.
                                              selectedFieldSettings:
                                                type: object
                                                description: >-
                                                  This is a map of field names to their
                                                  settings.
                                                x-go-type-skip-optional-pointer: true
                                                additionalProperties:
                                                  title: Field setting
                                                  type: object
                                                  properties:
                                                    default:
                                                      title: Default value for a field
                                                      description: >-
                                                        Only use one of stringValue,
                                                        integerValue, booleanValue.
                                                      type: object
                                                      properties:
[...]
